# Finds libzip.
#
# This module defines:
# LIBZIP_INCLUDE_DIRS
# LIBZIP_LIBRARIES
#

find_package(PkgConfig)
pkg_check_modules(PC_LIBZIP libzip)

find_path(LIBZIP_INCLUDE_DIR
          zip.h
          HINTS ${PC_LIBZIP_INCLUDEDIR} ${PC_LIBZIP_INCLUDE_DIRS})

find_library(LIBZIP_LIBRARY
             NAMES zip
             HINTS ${PC_LIBZIP_LIBDIR} ${PC_LIBZIP_LIBRARY_DIRS} )

if( WIN32 )
  get_filename_component(_LIBZIP_LIBRARY_DIR ${LIBZIP_LIBRARY} PATH)
  find_path(LIBZIP_CONFIG_INCLUDE_DIR
            zipconf.h
		    PATH_SUFFIXES libzip/include
            PATHS ${_LIBZIP_LIBRARY_DIR})
else ()
  find_path(LIBZIP_CONFIG_INCLUDE_DIR
            zipconf.h
            HINTS ${PC_LIBZIP_INCLUDEDIR} ${PC_LIBZIP_INCLUDE_DIRS})
endif()

set(LIBZIP_LIBRARIES ${LIBZIP_LIBRARY})
set(LIBZIP_INCLUDE_DIRS ${LIBZIP_INCLUDE_DIR} ${LIBZIP_CONFIG_INCLUDE_DIR})

include(FindPackageHandleStandardArgs)
find_package_handle_standard_args(LibZip DEFAULT_MSG
                                  LIBZIP_LIBRARY LIBZIP_INCLUDE_DIR)

mark_as_advanced(LIBZIP_INCLUDE_DIR LIBZIP_LIBRARY)

