#include<stdlib.h>
#include<stdio.h>
#include<sndfile.h>

// open impulse response file
SNDFILE *impopen(char *path, int sfmode, SF_INFO *sfinfo){

  SNDFILE *fp;

  if(sf_format_check(sfinfo) != 1 ){
	  fprintf(stderr, "error in format\n");
	  exit(1);
  }
  
//  printf("%s\n", path);
  
  if( (fp = sf_open(path, sfmode, sfinfo)) == NULL ){
    perror("sf_open");
    return NULL;
  }
  return fp;
}



//-----------------------------------------//
// read impulse response
//-----------------------------------------//
int readraw(SNDFILE *fp, SF_INFO *sfinfo, double **data, int *implength)
{

  int i,j;
  int count;
  float *tmp;
  
  count = sf_seek(fp, 0, SEEK_END); //frame数
  sf_seek(fp, 0, SEEK_SET);

  // printf("size = %d\n", count);
  
  if( (*data = (double *)malloc(sizeof(double) * count) ) 
      == NULL ){
    perror("malloc");
    exit(0);
  }

  if( (tmp = (float *)malloc(sizeof(float) * count) ) 
      == NULL ){
    perror("malloc");
    exit(0);
  }

  sf_readf_float(fp, tmp, count);

  *implength = count;

  for( i = 0; i < sfinfo->channels; i++)
	  for( j = 0; j < count; j++)
		  (*data)[i+j*sfinfo->channels] = (double)tmp[i+j*sfinfo->channels];
  
  free(tmp);
  
  return 1;
}

//-----------------------------------------//
// read impulse response file
//-----------------------------------------//
int readimp(char *fname, double **data, int *implength)
{
	SNDFILE *fp;
	SF_INFO sfinfo;
	
	sfinfo.samplerate = 16000;
	sfinfo.channels = 1;
	sfinfo.format = SF_FORMAT_RAW | SF_FORMAT_FLOAT | SF_ENDIAN_LITTLE;
	sfinfo.sections = -1;
	sfinfo.seekable = -1;

	fp = impopen(fname, SFM_READ, &sfinfo);

	readraw(fp, &sfinfo, data, implength);

	sf_close(fp);

#if 0
	for(i = 0; i < 10; i++){
		printf("%f ", data[i]);
	}
#endif
	
	return 1;
}





